diff -ur 4015/disc_prototypes.php 4015aes/disc_prototypes.php
--- 4015/disc_prototypes.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/disc_prototypes.php	2019-12-10 21:23:35.120671078 +0200
@@ -123,7 +123,7 @@
 			' && ({type} == '.ITEM_TYPE_SNMPV3.') && ({snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV.
 			' || {snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHNOPRIV.'))'
 	],
-	'snmpv3_privprotocol' =>		[T_ZBX_INT, O_OPT, null,	IN(ITEM_PRIVPROTOCOL_DES.','.ITEM_PRIVPROTOCOL_AES),
+	'snmpv3_privprotocol' =>		[T_ZBX_INT, O_OPT, null,	IN(ITEM_PRIVPROTOCOL_DES.','.ITEM_PRIVPROTOCOL_AES.','.ITEM_PRIVPROTOCOL_AES192C.','.ITEM_PRIVPROTOCOL_AES256C),
 		'(isset({add}) || isset({update})) && (isset({type}) && ({type} == '.ITEM_TYPE_SNMPV3.')'.
 			' && ({snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV.'))'
 	],
diff -ur 4015/host_discovery.php 4015aes/host_discovery.php
--- 4015/host_discovery.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/host_discovery.php	2019-12-10 21:23:35.120671078 +0200
@@ -123,7 +123,7 @@
 										' && ({snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV.
 										' || {snmpv3_securitylevel}=='.ITEM_SNMPV3_SECURITYLEVEL_AUTHNOPRIV.')'
 								],
-	'snmpv3_privprotocol' =>	[T_ZBX_INT, O_OPT, null, IN(ITEM_PRIVPROTOCOL_DES.','.ITEM_PRIVPROTOCOL_AES),
+	'snmpv3_privprotocol' =>	[T_ZBX_INT, O_OPT, null, IN(ITEM_PRIVPROTOCOL_DES.','.ITEM_PRIVPROTOCOL_AES.','.ITEM_PRIVPROTOCOL_AES192C.','.ITEM_PRIVPROTOCOL_AES256C),
 									'(isset({add}) || isset({update})) && isset({type}) && {type} == '.ITEM_TYPE_SNMPV3.
 										' && {snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV
 								],
diff -ur 4015/include/classes/api/services/CDRule.php 4015aes/include/classes/api/services/CDRule.php
--- 4015/include/classes/api/services/CDRule.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/include/classes/api/services/CDRule.php	2019-12-10 21:23:35.120671078 +0200
@@ -566,7 +566,9 @@
 				if ($dcheck['snmpv3_securitylevel'] == ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV) {
 					if (!array_key_exists('snmpv3_privprotocol', $dcheck)
 							|| $dcheck['snmpv3_privprotocol'] != ITEM_PRIVPROTOCOL_DES
-								&& $dcheck['snmpv3_privprotocol'] != ITEM_PRIVPROTOCOL_AES) {
+								&& $dcheck['snmpv3_privprotocol'] != ITEM_PRIVPROTOCOL_AES
+								&& $dcheck['snmpv3_privprotocol'] != ITEM_PRIVPROTOCOL_AES192C
+								&& $dcheck['snmpv3_privprotocol'] != ITEM_PRIVPROTOCOL_AES256C) {
 						self::exception(ZBX_API_ERROR_PARAMETERS,
 							_s('Incorrect value "%1$s" for "%2$s" field.',
 								$dcheck['snmpv3_privprotocol'], 'snmpv3_privprotocol'
diff -ur 4015/include/classes/api/services/CItemGeneral.php 4015aes/include/classes/api/services/CItemGeneral.php
--- 4015/include/classes/api/services/CItemGeneral.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/include/classes/api/services/CItemGeneral.php	2019-12-10 21:23:35.120671078 +0200
@@ -593,7 +593,7 @@
 				if ($fullItem['snmpv3_securitylevel'] == ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV) {
 					if (isset($fullItem['snmpv3_privprotocol']) && (zbx_empty($fullItem['snmpv3_privprotocol'])
 							|| !str_in_array($fullItem['snmpv3_privprotocol'],
-								[ITEM_PRIVPROTOCOL_DES, ITEM_PRIVPROTOCOL_AES]))) {
+								[ITEM_PRIVPROTOCOL_DES, ITEM_PRIVPROTOCOL_AES, ITEM_PRIVPROTOCOL_AES192C, ITEM_PRIVPROTOCOL_AES256C]))) {
 						self::exception(ZBX_API_ERROR_PARAMETERS, _s('Incorrect privacy protocol for item "%1$s".', $fullItem['name']));
 					}
 				}
diff -ur 4015/include/views/configuration.host.discovery.edit.php 4015aes/include/views/configuration.host.discovery.edit.php
--- 4015/include/views/configuration.host.discovery.edit.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/include/views/configuration.host.discovery.edit.php	2019-12-10 21:23:35.120671078 +0200
@@ -435,6 +435,8 @@
 	(new CRadioButtonList('snmpv3_privprotocol', (int) $this->data['snmpv3_privprotocol']))
 		->addValue(_('DES'), ITEM_PRIVPROTOCOL_DES)
 		->addValue(_('AES'), ITEM_PRIVPROTOCOL_AES)
+		->addValue(_('AES192C'), ITEM_PRIVPROTOCOL_AES192C)
+		->addValue(_('AES256C'), ITEM_PRIVPROTOCOL_AES256C)
 		->setModern(true),
 	'row_snmpv3_privprotocol'
 );
diff -ur 4015/include/views/configuration.item.edit.php 4015aes/include/views/configuration.item.edit.php
--- 4015/include/views/configuration.item.edit.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/include/views/configuration.item.edit.php	2019-12-10 21:23:35.124671085 +0200
@@ -562,6 +562,8 @@
 	$snmpv3_privprotocol = (new CRadioButtonList('snmpv3_privprotocol_names', (int) $data['snmpv3_privprotocol']))
 		->addValue(_('DES'), ITEM_PRIVPROTOCOL_DES)
 		->addValue(_('AES'), ITEM_PRIVPROTOCOL_AES)
+		->addValue(_('AES192C'), ITEM_PRIVPROTOCOL_AES192C)
+		->addValue(_('AES256C'), ITEM_PRIVPROTOCOL_AES256C)
 		->setModern(true)
 		->setEnabled(!$discovered_item);
 }
@@ -569,6 +571,8 @@
 	$snmpv3_privprotocol = (new CRadioButtonList('snmpv3_privprotocol', (int) $data['snmpv3_privprotocol']))
 		->addValue(_('DES'), ITEM_PRIVPROTOCOL_DES)
 		->addValue(_('AES'), ITEM_PRIVPROTOCOL_AES)
+		->addValue(_('AES192C'), ITEM_PRIVPROTOCOL_AES192C)
+		->addValue(_('AES256C'), ITEM_PRIVPROTOCOL_AES256C)
 		->setModern(true);
 }
 $itemFormList->addRow((new CLabel(_('Privacy protocol'), 'snmpv3_privprotocol')),
diff -ur 4015/include/views/configuration.item.massupdate.php 4015aes/include/views/configuration.item.massupdate.php
--- 4015/include/views/configuration.item.massupdate.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/include/views/configuration.item.massupdate.php	2019-12-10 21:23:35.124671085 +0200
@@ -246,6 +246,8 @@
 		(new CRadioButtonList('snmpv3_privprotocol', (int) $data['snmpv3_privprotocol']))
 			->addValue(_('DES'), ITEM_PRIVPROTOCOL_DES)
 			->addValue(_('AES'), ITEM_PRIVPROTOCOL_AES)
+			->addValue(_('AES192C'), ITEM_PRIVPROTOCOL_AES192C)
+			->addValue(_('AES256C'), ITEM_PRIVPROTOCOL_AES256C)
 			->setModern(true)
 	))
 		->setId('privprotocol_div')
diff -ur 4015/include/views/configuration.item.prototype.edit.php 4015aes/include/views/configuration.item.prototype.edit.php
--- 4015/include/views/configuration.item.prototype.edit.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/include/views/configuration.item.prototype.edit.php	2019-12-10 21:23:35.124671085 +0200
@@ -514,6 +514,8 @@
 	(new CRadioButtonList('snmpv3_privprotocol', (int) $this->data['snmpv3_privprotocol']))
 		->addValue(_('DES'), ITEM_PRIVPROTOCOL_DES)
 		->addValue(_('AES'), ITEM_PRIVPROTOCOL_AES)
+		->addValue(_('AES192C'), ITEM_PRIVPROTOCOL_AES192C)
+		->addValue(_('AES256C'), ITEM_PRIVPROTOCOL_AES256C)
 		->setModern(true),
 	'row_snmpv3_privprotocol'
 );
diff -ur 4015/include/views/js/configuration.discovery.edit.js.php 4015aes/include/views/js/configuration.discovery.edit.js.php
--- 4015/include/views/js/configuration.discovery.edit.js.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/include/views/js/configuration.discovery.edit.js.php	2019-12-10 21:23:35.124671085 +0200
@@ -108,6 +108,8 @@
 					(new CRadioButtonList('snmpv3_privprotocol', ITEM_PRIVPROTOCOL_DES))
 						->addValue(_('DES'), ITEM_PRIVPROTOCOL_DES, 'snmpv3_privprotocol_'.ITEM_PRIVPROTOCOL_DES)
 						->addValue(_('AES'), ITEM_PRIVPROTOCOL_AES, 'snmpv3_privprotocol_'.ITEM_PRIVPROTOCOL_AES)
+						->addValue(_('AES192C'), ITEM_PRIVPROTOCOL_AES192C, 'snmpv3_privprotocol_'.ITEM_PRIVPROTOCOL_AES192C)
+						->addValue(_('AES256C'), ITEM_PRIVPROTOCOL_AES256C, 'snmpv3_privprotocol_'.ITEM_PRIVPROTOCOL_AES256C)
 						->setModern(true),
 					'newCheckPrivProtocolRow'
 				)
diff -ur 4015/items.php 4015aes/items.php
--- 4015/items.php	2019-11-25 11:05:43.000000000 +0200
+++ 4015aes/items.php	2019-12-10 21:23:35.124671085 +0200
@@ -110,7 +110,7 @@
 	'snmpv3_authpassphrase' =>	[T_ZBX_STR, O_OPT, null,	null,
 		'(isset({add}) || isset({update})) && isset({type}) && {type} == '.ITEM_TYPE_SNMPV3.' && ({snmpv3_securitylevel} == '.
 		ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV.' || {snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHNOPRIV.')'],
-	'snmpv3_privprotocol' =>	[T_ZBX_INT, O_OPT, null,	IN(ITEM_PRIVPROTOCOL_DES.','.ITEM_PRIVPROTOCOL_AES),
+	'snmpv3_privprotocol' =>	[T_ZBX_INT, O_OPT, null,	IN(ITEM_PRIVPROTOCOL_DES.','.ITEM_PRIVPROTOCOL_AES.','.ITEM_PRIVPROTOCOL_AES192C.','.ITEM_PRIVPROTOCOL_AES256C),
 		'(isset({add}) || isset({update})) && isset({type}) && {type} == '.ITEM_TYPE_SNMPV3.' && {snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV],
 	'snmpv3_privpassphrase' =>	[T_ZBX_STR, O_OPT, null,	null,
 		'(isset({add}) || isset({update})) && isset({type}) && {type} == '.ITEM_TYPE_SNMPV3.' && {snmpv3_securitylevel} == '.ITEM_SNMPV3_SECURITYLEVEL_AUTHPRIV],